SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'FromerMaffongelli 5/16/2012 20:43'!
blueGhost

	^ Ghost new.! !

!PacManTest methodsFor: 'actors' stamp: 'NicolasAlejandro 5/20/2012 20:01'!
blueberry

	^ Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'FromerMaffongelli 5/16/2012 19:53'!
down

	 ^(0@(-1)).! !

!PacManTest methodsFor: 'construction block types' stamp: 'FromerMaffongelli 5/16/2012 20:44'!
ghostHouseDoorType

	^ GhostHouseDoor new.! !

!PacManTest methodsFor: 'movements' stamp: 'FromerMaffongelli 5/16/2012 19:53'!
left

	^(-1@0). ! !

!PacManTest methodsFor: 'construction block types' stamp: 'FromerMaffongelli 5/16/2012 21:07'!
leftTransporterType

	^ Transporter  new.! !

!PacManTest methodsFor: 'actors' stamp: 'PabloFromer 7/13/2012 00:07'!
pacManGame 

	^PacManGame  new.! !

!PacManTest methodsFor: 'actors' stamp: 'FromerMaffongelli 5/16/2012 21:09'!
pacman

	 ^ PacMan new.! !

!PacManTest methodsFor: 'movements' stamp: 'FromerMaffongelli 5/16/2012 19:53'!
right

	^(1@0).! !

!PacManTest methodsFor: 'construction block types' stamp: 'FromerMaffongelli 5/16/2012 21:10'!
spaceType

	^ Space new.! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 5/20/2012 23:25'!
test01GhostCanNotGoIntoAWall
	
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 00:07'!
test10WhenGameStartsScoreIsCero

	|pacmanGame|
	
	pacmanGame := self pacManGame.

	self assert: 0 equals: ( pacmanGame score ).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 01:10'!
test11WhenLivesStartsThereAreThreeLives

	|pacmanGame|
	
	pacmanGame := self pacManGame.

	self assert: 3 equals: ( pacmanGame lives ).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 00:54'!
test12AfterEatingFruitPillScoreIncreasesFiveHundredPoints

	|pacmanGame fruit|
	
	pacmanGame := self pacManGame.
	
	fruit := Fruit new.
	
	pacmanGame pacmanJustMetA: fruit.
	
	self assert: 500 equals: (pacmanGame score).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 01:10'!
test13AfterEatingSmallPillScoreIncreasesOneHundrerPoints

	|pacmanGame pacman smallPill|
	
	pacmanGame := self pacManGame.
	
	smallPill := BigPill new.
	
	pacmanGame pacmanJustMetA: smallPill.
	
	self assert: 100 equals: ( pacmanGame score).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 01:11'!
test14AfterEatingSmallPillScoreIncreasesTenPoints

	|pacmanGame pacman smallPill|
	
	pacmanGame := self pacManGame.
	
	smallPill := SmallPill new.
	
	pacmanGame pacmanJustMetA: smallPill.
	
	self assert: 10 equals: ( pacmanGame score).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 01:01'!
test15MeetingGhostIfNoBigPillEatedDecreasesLifes

	|pacmanGame pacman smallPill ghost|
	
	pacmanGame := self pacManGame.
	
	ghost := Ghost new.
	
	pacmanGame pacmanJustMetA: ghost.
	
	self assert: 2 equals: ( pacmanGame lives).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 01:06'!
test16MeetingGhostAfterBigPillEatedIncreasesTwoHundrerPointsAndDoesntDeacresesLifes

	|pacmanGame pacman bigPill ghost|
	
	pacmanGame := self pacManGame.
	
	ghost := Ghost new.
	bigPill := BigPill new.
	
	pacmanGame pacmanJustMetA: bigPill.
	self assert: 100 equals: ( pacmanGame score).
	pacmanGame pacmanJustMetA: ghost.
	
	self assert: 3 equals: ( pacmanGame lives).
	self assert: 300 equals: ( pacmanGame score).! !

!PacManTest methodsFor: 'tests' stamp: 'PabloFromer 7/13/2012 01:11'!
test17MeetingGhostIfNoBigPillEatedDecreasesLifesAndDoesntIncreasesScore

	|pacmanGame pacman smallPill ghost|
	
	pacmanGame := self pacManGame.
	
	ghost := Ghost new.
	
	pacmanGame pacmanJustMetA: ghost.
	
	self assert: 2 equals: ( pacmanGame lives).
	self assert: 0 equals: ( pacmanGame score).! !

!PacManTest methodsFor: 'movements' stamp: 'FromerMaffongelli 5/16/2012 19:54'!
up

	^(0@1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'FromerMaffongelli 5/16/2012 21:11'!
wallType

	^Wall new.! !

Object subclass: #Actor
	instanceVariableNames: 'position pacmanGame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 20:55'!
ask: aBlock toGo: aDirection.

self subclassResponsibility.! !

!Actor methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:34'!
position

	^position.! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:34'!
ask: aBlock toGo: aDirection 
	
	^ aBlock iAmAFruitAt: position AndIWantToMove: aDirection.! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:19'!
initialize 
	
	position := 4@4! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:12'!
pacmanJustMetYouLetMeKnowWhatToDo: aPacManGame.

	aPacManGame increseScore: 500.! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 20:59'!
ask: aBlock toGo: aDirection.

  ^aBlock iAmAGhostAt: position AndIWantToMove: aDirection.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:34'!
initialize 

	position:= (5@5).! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:12'!
pacmanJustMetYouLetMeKnowWhatToDo: aPacManGame.

	aPacManGame valueBlockForMeetingGhost.! !

Actor subclass: #PacMan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacMan methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 20:59'!
ask: aBlock toGo: aDirection.

  ^aBlock iAmAPacManAt: position AndIWantToMove: aDirection.! !

!PacMan methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 20:29'!
initialize 

	position := (0@0).! !

Object subclass: #Block
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Block methodsFor: 'as yet unclassified' stamp: 'PabloFromer 5/20/2012 23:18'!
iAmAFruitAt: aPosition AndIWantToMove: aDirection

 self subclassResponsibility.! !

!Block methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:13'!
iAmAGhostAt: aPosition AndIWantToMove: aDirection

 self subclassResponsibility.! !

!Block methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:14'!
iAmAPacManAt: aPosition AndIWantToMove: aDirection

 self subclassResponsibility.! !

!Block methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:05'!
nextPositionFor: anActor going: aDirection



	^anActor ask: self toGo: aDirection.
	
	
	


	! !

Block subclass: #GhostHouseDoor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:27'!
iAmAFruitAt: aPosition AndIWantToMove: aDirection 
	^ aDirection  + aPosition! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:01'!
iAmAGhostAt: aPosition AndIWantToMove: aDirection

 ^aDirection  + aPosition.! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:00'!
iAmAPacManAt: aPosition AndIWantToMove: aDirection

 ^aPosition.! !

Block subclass: #Space
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Space methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:21'!
iAmAFruitAt: aPosition AndIWantToMove: aDirection 
	^ aDirection + aPosition! !

!Space methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:10'!
iAmAGhostAt: aPosition AndIWantToMove: aDirection

 ^aDirection  + aPosition.! !

!Space methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:10'!
iAmAPacManAt: aPosition AndIWantToMove: aDirection

 ^aDirection  + aPosition.! !

Block subclass: #Transporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Transporter methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:30'!
iAmAFruitAt: aPosition AndIWantToMove: aDirection 
	^ (5@10)! !

!Transporter methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:06'!
iAmAGhostAt: aPosition AndIWantToMove: aDirection

 ^ aPosition.! !

!Transporter methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:07'!
iAmAPacManAt: aPosition AndIWantToMove: aDirection

 ^(3@10).! !

Block subclass: #Wall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Wall methodsFor: 'as yet unclassified' stamp: 'NicolasAlejandro 5/20/2012 20:14'!
iAmAFruitAt: aPosition AndIWantToMove: aDirection 
	^ aPosition! !

!Wall methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:11'!
iAmAGhostAt: aPosition AndIWantToMove: aDirection

 ^ aPosition.! !

!Wall methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/16/2012 21:11'!
iAmAPacManAt: aPosition AndIWantToMove: aDirection

 ^aPosition.! !

Object subclass: #PacManGame
	instanceVariableNames: 'score lives blockForMeetingGhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 00:24'!
bigPill

	^(BigPill pacmanGame: self).! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 00:38'!
increseScore: aNumber.

	score := score + aNumber.! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:03'!
initialize 

	score := 0.
	lives := 3.
	blockForMeetingGhost := [lives:=lives - 1].! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 00:05'!
lives

	^lives.! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 00:25'!
pacman

	^(PacMan pacmanGame: self).! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:03'!
pacmanEatedABigPillAdaptBlockForEatingGhosts.

	blockForMeetingGhost:=  [score := score + 200].! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:12'!
pacmanJustMetA: foodOrActor

	foodOrActor pacmanJustMetYouLetMeKnowWhatToDo: self.! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 00:05'!
score 

	^score.! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 00:24'!
smallPill

	^(SmallPill pacmanGame: self).! !

!PacManGame methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:02'!
valueBlockForMeetingGhost

     blockForMeetingGhost value.! !

Object subclass: #Pill
	instanceVariableNames: 'pacmanGame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Pill subclass: #BigPill
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BigPill methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:12'!
pacmanJustMetYouLetMeKnowWhatToDo: aPacManGame.

	aPacManGame increseScore: 100.
	aPacManGame pacmanEatedABigPillAdaptBlockForEatingGhosts.! !

!Pill methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:13'!
pacmanJustMetYouLetMeKnowWhatToDo: aPacManGame

	^self subclassResponsibility.! !

Pill subclass: #SmallPill
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SmallPill methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/13/2012 01:12'!
pacmanJustMetYouLetMeKnowWhatToDo: aPacManGame.

	aPacManGame increseScore: 10.! !
